function BangWintergrasp:BecomeLeader()
	self.db.profile.CurrentLeader=UnitName("player")
	id, name = GetChannelName("bangwgsync");
	if (id > 0 and name ~= nil) then
	    SendChatMessage("Leader", "CHANNEL", nil, GetChannelName("bangwgsync"))
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]|r Promoted to B!WG Leader. Zone invites unlocked. Type /bwg invite")
end
function BangWintergrasp:Dalaran()
        if ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) < 1500) and self.db.profile.Dalaran then
            StaticPopup_Show("POP_WHOINVITE")
		end
end
function BangWintergrasp:WhoControl()
if not BWGWhoInviteActive then return end
  if self.db.profile.CurrentLeader~=UnitName("player") then
     if self.db.profile.CurrentLeader=="?" then
       	    if self.db.profile.GlobalEnabled then
			id, name = GetChannelName("bangwgsync");
			if (id > 0 and name ~= nil) then
    		    SendChatMessage("WhoIsIt", "CHANNEL", nil, GetChannelName("bangwgsync"))
			end
			BangWintergrasp:ScheduleTimer("BecomeLeader",10)
		end
     else
		 -- Wait mode, someone else has leader
		    BangWintergrasp:ScheduleTimer("WhoControl",10)
	 end
  else
			if self.db.profile.WhoInvite and ((GetNumRaidMembers() < 40 and (IsRaidLeader() or IsRaidOfficer()))or GetNumRaidMembers() == 0) and self.db.profile.GlobalEnabled then
		    BangWintergrasp:AnnounceInvites()
			if not bwgknum then bwgknum=1 end
			    if bwgknum==1 then bwgsearch="Wintergrasp Rogue";
			elseif bwgknum==2 then bwgsearch="Wintergrasp Warrior"
			elseif bwgknum==3 then bwgsearch="Wintergrasp Hunter"
			elseif bwgknum==4 then bwgsearch="Wintergrasp Priest"
			elseif bwgknum==5 then bwgsearch="Wintergrasp Paladin"
			elseif bwgknum==6 then bwgsearch="Wintergrasp Druid"
			elseif bwgknum==7 then bwgsearch="Wintergrasp Shaman"
			elseif bwgknum==8 then bwgsearch="Wintergrasp Mage"
			elseif bwgknum==9 then bwgsearch="Wintergrasp Warlock"
			elseif bwgknum==10 then bwgsearch="Wintergrasp Death Knight";  bwgknum=1
			end
		    bwgknum=bwgknum+1
		    FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE");
			SendWho(bwgsearch)
		    BangWintergrasp:ScheduleTimer("WhoInvite",3)
			BangWintergrasp:ScheduleTimer("WhoControl",4)
		end
	end
end
function BangWintergrasp:WhoInvite()
if not BWGWhoInviteActive then return end
	if self.db.profile.WhoInvite and (self.db.profile.Enabled) then
				BWGInviteBlacklist = BWGInviteBlacklist or {}
				if not BWGInviteBlacklist.blacklisted then BWGInviteBlacklist.blacklisted={ } end
				local numWhos, totalCount = GetNumWhoResults();
				for i=1,numWhos do
		            bwgcharname=nil
					bwgcharname = GetWhoInfo(i)
					if bwgcharname then
						 if (not BWGInviteBlacklist.blacklisted[bwgcharname]) and (not(bwgcharname==UnitName("player"))) and((GetNumRaidMembers() < 40 and (IsRaidLeader() or IsRaidOfficer()))or GetNumRaidMembers() == 0) then
                            BWGInviteBlacklist.blacklisted[bwgcharname] = "BL"
							InviteUnit(bwgcharname)
                            if (not self.db.profile.APromoteOff) then BangWintergrasp:ScheduleTimer("Promote",15,bwgcharname) end
                                SendChatMessage("[B!WG] Auto-Invites to WG Battle raid going out. Whisper 'invite' if you miss it.", "WHISPER", nil, bwgcharname)
						 else
						      --DEFAULT_CHAT_FRAME:AddMessage("BL: "..bwgcharname)
						 end
					end

				end
	end
	FriendsFrame:RegisterEvent("WHO_LIST_UPDATE");
end 
function BangWintergrasp:Promote(promotee)
	if UnitInRaid(promotee) then
		if (not self.db.profile.APromoteOff) then PromoteToAssistant(promotee)  end
	end
end
function BangWintergrasp:InviteW(msg,sender)
	local msg=string.lower(msg)
	if(self.db.profile.WhisperInvite) and (((select(1,GetMapInfo())) == "LakeWintergrasp") or self.db.profile.EInvite or self.db.profile.Dalaran) and (self.db.profile.Enabled) then
		if ((GetNumRaidMembers() < 40 and (IsRaidLeader() or IsRaidOfficer()))or GetNumRaidMembers() == 0) then
			if (string.find(msg, "invite") or string.find(msg, "inv")) then
				InviteUnit(sender)
				BangWintergrasp:ScheduleTimer("Promote",15,sender)
			end
		end
	end
end
function BangWintergrasp:InviteG(msg,sender, channel)
	local msg=string.lower(msg)
	if (self.db.profile.GlobalInvite) and (not(sender==UnitName("player"))) and (((select(1,GetMapInfo())) == "LakeWintergrasp") or self.db.profile.EInvite or self.db.profile.Dalaran) and (self.db.profile.Enabled) then
			if ((channel == "General - Wintergrasp") or (channel == "LocalDefense - Wintergrasp ") or (channel == "Bypass")) and ((IsRaidOfficer()  == 1) and (GetNumRaidMembers() > 0) and (GetNumRaidMembers() < 40))then
				if (string.find(msg,"invite") or string.find(msg,"inv")) and not string.find(msg,"pst") then
					InviteUnit(sender)
				end
			else
				return
			end
    end
end
function BangWintergrasp:CHAT_MSG_SAY(aevn, msg, author, language, fullchan, target, tag, zoneID, channum, channame)
if select(1,GetMapInfo()) == "LakeWintergrasp" or select(1,GetMapInfo()) == "Dalaran"	then BangWintergrasp:InviteG(msg,author,"Bypass") end
end
function BangWintergrasp:PARTY_MEMBERS_CHANGED(...)
    BangWintergraspGetZone = (select(1,GetMapInfo()))
    if ((BangWintergraspGetZone == "LakeWintergrasp") and BWGWhoInviteActive and self.db.profile.Enabled) or (BangWintergraspGetZone == "Dalaran" and BWGWhoInviteActive and self.db.profile.Enabled and self.db.profile.Dalaran) then
		ConvertToRaid();
		if  (GetNumRaidMembers() > 25) and (IsRaidLeader()) and BWGWhoInviteActive and self.db.profile.Enabled then
			for i=1,GetNumRaidMembers() do
				if UnitExists("raid"..i) and UnitInRaid("raid"..i) then
				 if not UnitIsConnected("raid"..i) then
				  	UninviteUnit("raid"..i)
				  end;
				end
			end
		end
		if  (GetNumRaidMembers() > 39) and (IsRaidLeader() and self.db.profile.Enabled and BWGWhoInviteActive) then
			local s = "[B!WG] This raid is full - Start another."
			local index = GetChannelName("General - Wintergrasp")
			if (index~=nil) and not bwgfullannounce then
			  bwgfullannounce=true
			  SendChatMessage(s , "CHANNEL", nil, index);
			end
			id, name = GetChannelName("bangwgsync");
			if (id > 0 and name ~= nil) then
			    SendChatMessage("WhoIsIt", "CHANNEL", nil, GetChannelName("bangwgsync"))
			end
		end
	end
end

-- Info from zone
function BangWintergrasp:WhoPop(poptest)
		if not self.db.profile.WhoInvite then return end
        if ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) > 2830) then
            BWGShowpop=true
        elseif BWGShowpop==true and  ((tonumber(BangWintergrasp.db.profile.TimeTillWGB)-GetTime()) < 950) then
            BWGShowpop=false
            if self.db.profile.AutoWho then BangWintergrasp:DoPopFunc() else StaticPopup_Show("POP_WHOINVITE"); end
		end
end
function BangWintergrasp:DoPopFunc()
        BWGShowpop=false;
		BWGWhoInviteActive = true;
        BWGInviteBlacklist.blacklisted={ };
		BangWintergrasp:WhoControl();
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[B!WG]: |r Zone invites on. /bwg stop (to disable)")
        BangWintergrasp:AnnounceInvites()
end
function BangWintergrasp:AnnounceInvites()
if not BWGWhoInviteActive then return end
		if not bwgDelayAnnounce then bwgDelayAnnounce = GetTime()-1 end
		if (bwgDelayAnnounce - GetTime() < 0) and ((GetNumRaidMembers() < 39 and (IsRaidLeader() or IsRaidOfficer()))or GetNumRaidMembers() == 0) then
            bwgDelayAnnounce=GetTime()+60
			local s = "[B!WG] Wintergrasp Battle Invites going out ("..GetNumRaidMembers().."/40). Whisper 'invite' if you miss yours."
			local index = GetChannelName("General - Wintergrasp")
			SendChatMessage(s , "SAY", nil);
			if (index~=nil) then
			  SendChatMessage(s , "CHANNEL", nil, index);
			end
		end
end




